/* egg.sl - Egg shell.
 */

#include "includes/specular/Blinn.h"
#include "includes/diffuse/Lambert.h"


surface egg( float diff = 1.0,
                    spec = 1.0,
                    rough = 0.25,
                    fresnel = 2.0,
                    var = 0.1;
              color spec_color = color(1,1,1)  )
{
	normal Normal = faceforward( normalize(N), I, N );
	vector View = normalize( -I );
	point Po = transform("object",P);
	
	Oi = Os;
	Ci = color(0,0,0);

	illuminance( P, Normal, PI/2 )
	{
		vector Light = normalize( L );
		float r = 1.0 - (((noise(Po*8) * 0.75) + (noise(Po*64) * 0.25)) * var);
		
		
		// Lambert diffuse
		Ci += color(1,1,1) * Cs * Cl * LambertBRDF( N, I, L ) * diff * r;
		
		// Blinn specular
		float b = BlinnBRDF( N, I, L, rough, fresnel );
		
		Ci += color(1,1,1) * spec_color * Cl * b * spec;
	}
}


