/* Henyey-Greenstein diffuse BRDF.
 * N, I, and L should be passed as-is directly from the shader.
 * Oops, this is a phase function.  Should be used between the Light and View vectors, without the normal.
 */

float HenyeyGreensteinBRDF( normal N; vector I, L; float g )
{
	normal Normal = faceforward( normalize(N), I, N );
	vector View = normalize( -I );
	vector Light = normalize( L );
	
	float nl = View . Light;
	float g2 = g * g;
	
	float a = 1 + g2 - (2 * g * nl);
	a = pow( a, 1.5 );
	float b = 0.5 * ((1-g2) / a);
	
	
	return ((Normal.Light) + b) / 2;
}
