/* test.sl - Nathan's shader playground.
 */

#include "includes/specular/Blinn.h"
#include "includes/diffuse/Lambert.h"


float mymix( float a, b, t )
{
	//float erp = (6*t*t*t*t*t) - (15*t*t*t*t) + (10*t*t*t);
	float erp = (3*t*t)-(2*t*t*t);
	return a + erp * (b - a);
}
float mynoise( float x, y, z )
{
	
	return cellnoise( mod((x),67) + mod((y*y*y),89) + mod((z*z*z*z*z),113) );
}

float mynoiselin( point p )
{
	float x = xcomp(p);
	float x1 = floor(x);
	float x2 = ceil( x);
	
	float y = ycomp(p);
	float y1 = floor(y);
	float y2 = ceil( y);
	
	float z = zcomp(p);
	float z1 = floor(z);
	float z2 = ceil( z);
	
	
	
	float a = mymix( mynoise(x1,y1,z1), mynoise(x2,y1,z1), (x-x1) );
	float b = mymix( mynoise(x1,y2,z1), mynoise(x2,y2,z1), (x-x1) );
	
	float c = mymix( mynoise(x1,y1,z2), mynoise(x2,y1,z2), (x-x1) );
	float d = mymix( mynoise(x1,y2,z2), mynoise(x2,y2,z2), (x-x1) );
	
	
	
	float j = mymix( a, b, (y-y1) );
	float k = mymix( c, d, (y-y1) );
	
	
	float final = mix( j, k, (z-z1) );
	
	return final;
}

surface test( float ang=PI/6, diff=1 )
{
	normal Normal = faceforward( normalize(N), I, N );
	vector View = normalize( -I );
	point Ps = transform("shader",P);
	
	Oi = Os;
	float fac = mynoiselin(Ps*10);
	Ci = color(1) * fac;
}


